<?php
/**
 * webEdition CMS
 *
 * $Rev: f1d8803c411c $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-03-16 16:58 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
/*
 * map needed variables for the program here, for example map version number
 */

$LU_Variables = [
	'clientContent' => false, //true on installer
	'clientDBcharset' => we_database_base::getCharset(),
	'clientDBcollation' => we_database_base::getCollation(),
	'clientDomain' => urlencode($_SERVER['SERVER_NAME']),
	'clientExtension' => DEFAULT_DYNAMIC_EXT,
	'clientHotfixNr' => (defined('WE_VERSION_HOTFIX_NR')) ? WE_VERSION_HOTFIX_NR : 0,
	'clientInstalledAppMeta' => '', //we_tool_lookup::getAllTools(true, false, true),
	'clientInstalledLanguages' => liveUpdateFunctions::getInstalledLanguages(),
	'clientInstalledModules' => we_modules_info::getUserEnabledModules(),
	'clientLng' => $GLOBALS['WE_LANGUAGE'] . ($GLOBALS['we']['Charset']['Backend'] === 'UTF-8' ? '_UTF-8' : ''),
	'clientMySQLType' => we_database_base::getMysqlVer()[1],
	'clientMySQLVersion' => we_database_base::getMysqlVer()[0],
	'clientPhpExtensions' => implode(',', get_loaded_extensions()),
	'clientPhpVersion' => PHP_VERSION,
	'clientServerSoftware' => $_SERVER['SERVER_SOFTWARE'],
	'clientSessionID' => session_id(),
	'clientSessionManagement' => SYSTEM_WE_SESSION,
	'clientSessionName' => session_name(),
	'clientSubVersion' => WE_SVNREV,
	'clientSyslng' => WE_LANGUAGE,
	'clientUpdateUrl' => getServerUrl() . getScriptName(),
	'clientVersion' => WE_VERSION,
	'clientVersionBranch' => (defined('WE_VERSION_BRANCH')) ? WE_VERSION_BRANCH : '',
	'clientVersionName' => (defined('WE_VERSION_NAME')) ? WE_VERSION_NAME : '',
	'clientVersionSupp' => (defined('WE_VERSION_SUPP')) ? WE_VERSION_SUPP : '',
	'clientVersionSuppVersion' => (defined('WE_VERSION_SUPP_VERSION')) ? WE_VERSION_SUPP_VERSION : '',
	'testUpdate' => empty($_SESSION['weS']['testUpdate']) ? 0 : $_SESSION['weS']['testUpdate'],
];

// These request variables listed here are NOT submitted to the server - fill it
// to keep requests small
$LU_IgnoreRequestParameters = [
	'we_mode',
	'cookie',
	'treewidth_main',
	session_name(),
	'we' . session_id()
];
