<?php
/**
 * webEdition CMS
 *
 * $Rev: 1a73906214ea $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-07-01 23:44 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
return [
	'new' => [
		'text' => g_l('modules_workflow', '[menu][new]'),
		'perm' => [we_base_perm::WORKFLOW_NEW],
		'icon' => 'fa fa-plus-circle',
	],
	['text' => g_l('modules_workflow', '[menu][new]'),
		'cmd' => 'new_workflow',
		'perm' => [we_base_perm::WORKFLOW_NEW],
		'parent' => 'new',
	],
	'workflow' => [
		'text' => g_l('modules_workflow', '[menu][workflow]'),
		'icon' => 'fa fa-gears'
	],
	['text' => g_l('modules_workflow', '[menu][save]'),
		'parent' => 'workflow',
		'cmd' => 'save_workflow',
		'perm' => [we_base_perm::WORKFLOW_EDIT],
	],
	['text' => g_l('modules_workflow', '[menu][delete]'),
		'parent' => 'workflow',
		'cmd' => 'delete_workflow',
		'perm' => [we_base_perm::WORKFLOW_DELETE],
	],
	['parent' => 'workflow',],
	/*
	  [
	  'text'=> g_l('modules_workflow','[menu][reload]'),
	  'parent'=> 'workflow',
	  'cmd'=> 'reload_workflow',
	  'enabled'=> '0',
	  ],
	  $we_menu_workflow['000880']['parent'] = 'workflow'; // separator
	 */
	['text' => g_l('modules_workflow', '[menu][empty_log]') . '&hellip;',
		'parent' => 'workflow',
		'cmd' => 'empty_log',
		'perm' => [we_base_perm::WORKFLOW_EMPTY_LOG],
	],
	['parent' => 'workflow',],
	['text' => g_l('modules_workflow', '[menu][quit]'),
		'parent' => 'workflow',
		'cmd' => 'exit_workflow',
	],
];
