<?php

/**
 * webEdition CMS
 *
 * $Rev: b30b50c8b58f $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-10-08 21:24 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
/*  a class for handling flashDocuments. */

class we_contents_pdf extends we_otherDocument{

	function __construct(){
		parent::__construct();
		$this->ContentType = we_base_ContentTypes::PDF;
	}

	/**
	 * create instance of weMetaData to access metadata functionality:
	 */
	protected function getMetaDataReader($force = false){
		return we_contents_binaryDocument::getMetaDataReader(true);
	}

	function getDocumentData($path = '', $size = -1){
		$name = $this->getElement('data', we_contents_base::ETYPE_TEXT);
		if(file_exists($name) && (filesize($name) * 2 < we_convertIniSizes(ini_get('memory_limit')))){
			$pdf = new we_helpers_pdf2text($name);
			return CheckAndConvertISOfrontend(str_replace(['\\n', '\\r'], '', $pdf->processText()));
		}
		return '';
	}

	public function setMetaDataFromFile($file){
		if($this->Extension === '.pdf' && file_exists($file)){
			$pdf = new we_helpers_pdf2text($file);
			$metaData = $pdf->getInfo();
			if($metaData){
				if(isset($metaData['Title']) && !$this->getElement(self::TITLE_FIELD, self::ETYPE_TEXT)){
					$this->setElement(self::TITLE_FIELD, $metaData['Title']);
				}
				if(isset($metaData['Keywords']) && !$this->getElement(self::KEYWORD_FIELD, self::ETYPE_TEXT)){
					$this->setElement(self::KEYWORD_FIELD, $metaData['Keywords']);
				}
				if(isset($metaData['Subject']) && !$this->getElement(self::DESCRIPTION_FIELD, self::ETYPE_TEXT)){
					$this->setElement(self::DESCRIPTION_FIELD, $metaData['Subject']);
				}
			}
		}
	}

}
