<?php

/**
 * webEdition CMS
 *
 * $Rev: 77e7a835ca98 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-07-30 22:27 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_editor_classFolderFields extends we_editor_base{

	public function show(){
		switch(we_base_request::_(we_base_request::STRING, 'do')){
			case we_folder::ACTION_DELETE:
				$this->we_doc->deleteObjects($this->jsCmd);
				break;
			case we_folder::ACTION_UNPUBLISH:
				$this->we_doc->publishObjects($this->jsCmd, false);
				break;
			case we_folder::ACTION_PUBLISH:
				$this->we_doc->publishObjects($this->jsCmd);
				break;
			case we_folder::ACTION_CATEGORY_ADD:
				$this->we_doc->changeCats($this->jsCmd, true);
				break;
			case we_folder::ACTION_CATEGORY_DELETE:
				$this->we_doc->changeCats($this->jsCmd, false);
				break;
			case we_folder::ACTION_UNSEARCHABLE:
				$this->we_doc->setObjectProperty('IsSearchable', false);
				break;
			case we_folder::ACTION_SEARCHABLE:
				$this->we_doc->setObjectProperty('IsSearchable', true);
				break;
			case we_folder::ACTION_COPY_CHARSET:
				$this->we_doc->setObjectProperty('Charset');
				break;
			case we_folder::ACTION_COPY_WS:
				$this->we_doc->setObjectProperty('Workspaces');
				break;
			case we_folder::ACTION_COPY_TID:
				$this->we_doc->setObjectProperty('TriggerID');
				break;
		}

		return $this->getPage(we_html_multiIconBox::getHTML('', [
					['html' => $this->we_doc->getSearchDialog()],
					['html' => $this->we_doc->getSearch()],
					]
					, true), $this->we_doc->getSearchJS(), [], false//don't make form
		);
	}

}
