<?php

/**
 * webEdition CMS
 *
 * $Rev: 096b1a1b079c $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-10-08 17:38 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_editor_functions{

	private static function initVars(){
		$GLOBALS['we_EDITOR'] = true;

// init document
//we_session assumes to have transaction in parameter 'we_transaction'
		$we_transaction = $GLOBALS['we_transaction'] = we_base_request::_(we_base_request::TRANSACTION, 'we_transaction', we_base_request::_(we_base_request::TRANSACTION, 'we_cmd', 0, 1));

		$GLOBALS['we_doc'] = we_contents_document::initDoc(isset($_SESSION['weS']['we_data'][$we_transaction]) ? $_SESSION['weS']['we_data'][$we_transaction] : []);

//	if document is locked - only Preview mode is possible. otherwise show warning.
		self::documentLocking($GLOBALS['we_doc']);
		return $GLOBALS['we_doc'];
	}

	public static function processSchedulerCmd($cmd0){
		$we_doc = self::initVars();
		switch($cmd0){
			case 'schedule_add':
				$we_doc->add_schedule();
				break;
			case 'schedule_del':
				$we_doc->del_schedule(we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1));
				break;
			case 'schedule_delete_schedcat':
				$we_doc->delete_schedcat(we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 2));
				break;
			case 'schedule_delete_all_schedcats':
				$we_doc->schedArr[we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1)]['CategoryIDs'] = '';
				break;
			case 'schedule_add_schedcat':
				$we_doc->add_schedcat(we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 2));
				break;
		}
		self::includeEditorDefault($we_doc, $GLOBALS['we_transaction'], null);
	}

	public static function processFilterCmd($cmd0){
		$we_doc = self::initVars();
		switch($cmd0){
			case 'customer_applyWeDocumentCustomerFilterFromFolder':
				$we_doc->applyWeDocumentCustomerFilterFromFolder();
				break;
		}
		self::includeEditorDefault($we_doc, $GLOBALS['we_transaction'], null);
	}

	public static function processUsersCmd($cmd0){
		$we_doc = self::initVars();
		switch($cmd0){
			case 'users_add_owner':
				$we_doc->add_owner(we_base_request::_(we_base_request::INTLISTA, 'we_cmd', [], 1));
				break;
			case 'users_del_owner':
				$we_doc->del_owner(we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1));
				break;
			case 'users_add_user':
				$we_doc->add_user(we_base_request::_(we_base_request::INTLISTA, 'we_cmd', [], 1));
				break;
			case 'users_del_user':
				$we_doc->del_user(we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1));
				break;
			case 'users_del_all_owners':
				$we_doc->del_all_owners();
				break;
		}
		self::includeEditorDefault($we_doc, $GLOBALS['we_transaction'], null);
	}

	public static function processObjectCmd($cmd0){
		$we_doc = self::initVars();
		switch($cmd0){
			case 'object_add_workspace':
				$we_doc->add_workspace(we_base_request::_(we_base_request::INT, 'we_cmd', false, 1));
				break;
			case 'object_del_workspace':
				$we_doc->del_workspace(we_base_request::_(we_base_request::INT, 'we_cmd', false, 1));
				break;
			case 'object_ws_from_class':
				$we_doc->ws_from_class();
				break;
			case 'object_changeTempl_ob':
				$we_doc->changeTempl_ob(we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 2));
				break;
			case 'object_add_css':
				$we_doc->add_css(we_base_request::_(we_base_request::INTLISTA, 'we_cmd', 0, 1));
				break;
			case 'object_del_css':
				$we_doc->del_css(we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1));
				break;
		}
		self::includeEditorDefault($we_doc, $GLOBALS['we_transaction'], null);
	}

	public static function processPropertyCmd($cmd0){
		$we_doc = self::initVars();
		$reload = null;
		switch($cmd0){
			case 'copyDocumentSelect':
			case 'copyDocument':
				$we_doc->InWebEdition = true;
				if($we_doc->copyDoc(we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1)) && $we_doc instanceof we_template){
					$reload = new we_base_jsCmd();
					$reload->addCmd('reloadMainEditor');
				}
				break;
			case 'add_navi':
				$we_doc->addNavi(we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1), we_base_request::_(we_base_request::STRING, 'we_cmd', '', 2), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 3), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 4));
				break;
			case 'delete_navi':
				$we_doc->delNavi(we_base_request::_(we_base_request::FILE, 'we_cmd', '', 1));
				break;
			case 'delete_all_navi':
				$we_doc->delAllNavi();
				break;
			case 'add_cat':
				$we_doc->addCat(we_base_request::_(we_base_request::INTLISTA, 'we_cmd', 0, 1));
				break;
			case 'delete_cat':
				$we_doc->delCat(we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1));
				break;
			case 'delete_all_cats':
				$we_doc->Category = '';
				break;
		}
		self::includeEditorDefault($we_doc, $GLOBALS['we_transaction'], $reload);
	}

	public static function processImageCmd($cmd0){
		$we_doc = self::initVars();
		switch($cmd0){
			case 'doImage_convertGIF':
				$we_doc->convert('gif');
				break;
			case 'doImage_convertPNG':
				$we_doc->convert('png');
				break;
			case 'doImage_convertJPEG':
				$we_doc->convert('jpg', we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1));
				break;
			case 'doImage_crop':
				$filename = TEMP_PATH . we_base_file::getUniqueId();
				we_base_file::insertIntoCleanUp($filename);
				copy($we_doc->getElement('data'), $filename);
//$filename = weFile::saveTemp($we_doc->getElement('data'));

				$x = we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1);
				$y = we_base_request::_(we_base_request::INT, 'we_cmd', 0, 2);
				$width = we_base_request::_(we_base_request::INT, 'we_cmd', 0, 3);
				$height = we_base_request::_(we_base_request::INT, 'we_cmd', 0, 4);

				$img = Image_Transform::factory('GD');
				if(PEAR::isError($stat = $img->load($filename))){
					trigger_error($stat->getMessage() . ' Filename: ' . $filename);
				}
				if(PEAR::isError($stat = $img->crop($width, $height, $x, $y))){
					trigger_error($stat->getMessage() . ' Filename: ' . $filename);
				}
				if(PEAR::isError($stat = $img->save($filename))){
					trigger_error($stat->getMessage() . ' Filename: ' . $filename);
				}

				$we_doc->setElement('data', $filename);
				$we_doc->setElement('width', $width, 'attrib', we_contents_base::ETYPE_NUMBER);
				$we_doc->setElement('origwidth', $width, 'attrib', we_contents_base::ETYPE_NUMBER);
				$we_doc->setElement('height', $height, 'attrib', we_contents_base::ETYPE_NUMBER);
				$we_doc->setElement('origheight', $height, 'attrib', we_contents_base::ETYPE_NUMBER);
				$we_doc->DocChanged = true;
				break;
			case 'del_thumb':
				$we_doc->del_thumbnails(we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1));
				break;
			case 'do_add_thumbnails':
				$we_doc->add_thumbnails(we_base_request::_(we_base_request::INTLISTA, 'we_cmd', [], 1));
				break;
			case 'resizeImage':
				$we_doc->resizeImage(we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 2), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 3));
				break;
			case 'rotateImage':
				$we_doc->rotateImage(we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 2), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 3), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 4));
				break;
		}
		self::includeEditorDefault($we_doc, $GLOBALS['we_transaction'], null);
	}

	public static function processEditorCmd($cmd0){
		$we_doc = self::initVars();
		$jsCmd = null;
		switch($cmd0){
			case 'load_editor':
// set default tab for creating new imageDocuments to "metadata":
				if($we_doc->ContentType == we_base_ContentTypes::IMAGE && $we_doc->ID == 0){
					$_SESSION['weS']['EditPageNr'] = $we_doc->EditPageNr = we_base_constants::WE_EDITPAGE_CONTENT;
				}
				break;
			case 'delete_list':
				$we_doc->removeEntryFromList(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1), we_base_request::_(we_base_request::STRING, 'we_cmd', 0, 2), we_base_request::_(we_base_request::CMD, 'we_cmd', '', 3));
				break;
			case 'insert_entry_at_list':
				$we_doc->insertEntryAtList(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1), we_base_request::_(we_base_request::STRING, 'we_cmd', 0, 2), we_base_request::_(we_base_request::INT, 'we_cmd', 1, 3));
				break;
			case 'up_entry_at_list':
				$we_doc->upEntryAtList(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1), we_base_request::_(we_base_request::STRING, 'we_cmd', 0, 2), we_base_request::_(we_base_request::INT, 'we_cmd', 1, 4));
				break;
			case 'down_entry_at_list':
				$we_doc->downEntryAtList(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1), we_base_request::_(we_base_request::STRING, 'we_cmd', 0, 2), we_base_request::_(we_base_request::INT, 'we_cmd', 1, 4));
				break;
			case 'up_link_at_list':
				$we_doc->upEntryAtLinklist(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 2));
				break;
			case 'down_link_at_list':
				$we_doc->downEntryAtLinklist(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 2));
				break;
			case 'add_entry_to_list':
				$we_doc->addEntryToList(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1), we_base_request::_(we_base_request::INT, 'we_cmd', 1, 2));
				break;
			case 'add_link_to_linklist':
				$GLOBALS['we_list_inserted'] = we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1);
				$we_doc->addLinkToLinklist($GLOBALS['we_list_inserted']);
				break;
			case 'delete_linklist':
				$we_doc->removeLinkFromLinklist(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1), we_base_request::_(we_base_request::INT, 'we_cmd', 0, 2), we_base_request::_(we_base_request::CMD, 'we_cmd', '', 3));
				break;
			case 'insert_link_at_linklist':
				$GLOBALS['we_list_insertedNr'] = abs(we_base_request::_(we_base_request::INT, 'we_cmd', 0, 2));
				$GLOBALS['we_list_inserted'] = we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1);
				$we_doc->insertLinkAtLinklist($GLOBALS['we_list_inserted'], $GLOBALS['we_list_insertedNr']);
				break;
			case 'change_linklist':
				$we_doc->changeLinklist(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1));
				break;
			case 'change_link':
				$we_doc->changeLink(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1));
				break;
			case 'doctype_changed':
				$we_doc->changeDoctype('', true);
				$jsCmd = new we_base_jsCmd();
				$jsCmd->addCmd('reload_editfooter', $GLOBALS['we_transaction']);
				$jsCmd->addCmd('reload_edit_header', $GLOBALS['we_transaction']);
				break;
			case 'template_changed':
				$we_doc->setDocumentControlElements();
				$jsCmd = new we_base_jsCmd();
				$jsCmd->addCmd('reload_editfooter', $GLOBALS['we_transaction']);
				$jsCmd->addCmd('reload_edit_header', $GLOBALS['we_transaction']);
				break;
			case 'remove_image':
				$we_doc->remove_image(we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1));
				break;
			case 'wrap_on_off':
				$_SESSION['weS']['we_wrapcheck'] = we_base_request::_(we_base_request::BOOL, 'we_cmd', false, 1);
				$we_doc->EditPageNr = we_base_constants::WE_EDITPAGE_CONTENT;
				$_SESSION['weS']['EditPageNr'] = we_base_constants::WE_EDITPAGE_CONTENT;
				break;
			case 'restore_defaults':
				$we_doc->restoreDefaults();
				break;
			case 'switch_edit_page':
				$_SESSION['weS']['EditPageNr'] = we_base_request::_(we_base_request::INT, 'we_cmd', 0, 1);
				$we_doc->EditPageNr = $_SESSION['weS']['EditPageNr'];
				if($_SESSION['weS']['we_mode'] == we_base_constants::MODE_SEE){
					$jsCmd = new we_base_jsCmd();
					$jsCmd->addCmd('reload_editfooter', $GLOBALS['we_transaction']);
				}
				break;
			case 'delete_link':
				$name = we_base_request::_(we_base_request::STRING, 'we_cmd', '', 1);
				$we_doc->delElement($name);
				break;
			case 'revert_published':
				$we_doc->revert_published();
				break;
		}
		self::includeEditor($we_doc, $GLOBALS['we_transaction'], $jsCmd);
	}

	private static function unPublishInc($we_transaction, $we_responseText = '', $we_responseTextType = '', we_base_jsCmd $jsCmd = null, $we_responseJS = []){
		echo we_html_tools::getHtmlTop('', '', '', we_html_element::jsScript(JS_DIR . 'editor_save.js', '', ['id' => 'loadVarEditor_save', 'data-editorSave' => setDynamicVar([
					'we_editor_save' => false,
					'we_transaction' => $we_transaction,
					'isSEEMode' => $_SESSION['weS']['we_mode'] == we_base_constants::MODE_SEE,
					'we_JavaScript' => [],
					'we_responseText' => $we_responseText,
					'we_responseTextType' => $we_responseTextType,
					'we_cmd5' => [],
					'we_responseJS' => $we_responseJS,
			])]) . ($jsCmd ? $jsCmd->getCmds() : ''), we_html_element::body());
	}

	public static function saveInc($we_transaction, $we_doc, $we_responseText = '', $we_responseTextType = '', array $wejs = [], $wasSaved = false, $saveTemplate = false, $we_responseJS = [
		], $isClose = false, $showAlert = false, $publish_doc = false){
		$reload = [];
		$we_responseJS = empty($we_responseJS) ? [] : $we_responseJS;

		if(!empty($wasSaved)){
			// DOC was saved, mark open tabs to reload if necessary
			// was saved - not hot anymore

			switch($we_doc->ContentType){
				case we_base_ContentTypes::FOLDER:
					if($we_doc->wasMoved()){
						$reload[$we_doc->Table] = $GLOBALS['DB_WE']->getAllq('SELECT f.ID FROM ' . $we_doc->Table . ' f INNER JOIN ' . LOCK_TABLE . ' l ON f.ID=l.ID AND l.tbl="' . stripTblPrefix($we_doc->Table) . '" WHERE f.Path LIKE "' . $we_doc->Path . '/%"', true);
					}
					break;

				case we_base_ContentTypes::TEMPLATE: // #538 reload documents based on this template
					$reloadDocsTempls = we_rebuild_base::getTemplAndDocIDsOfTemplate($we_doc->ID, false, false, true, true);

					// reload all documents based on this template
					$reload[FILE_TABLE] = $reloadDocsTempls['documentIDs'];
					//no need to reload the edit tab, since this is not changed & Preview is always regenerated
//			$reload[TEMPLATES_TABLE] = implode(',', $reloadDocsTempls['templateIDs']);

					break;
				case we_base_ContentTypes::OBJECT:
					$reload[OBJECT_FILES_TABLE] = array_map('intval', $GLOBALS['DB_WE']->getAllq('SELECT `of`.ID FROM ' . OBJECT_FILES_TABLE . ' `of` INNER JOIN ' . LOCK_TABLE . ' l ON `of`.ID=l.ID AND l.tbl="' . stripTblPrefix(OBJECT_FILES_TABLE) . '" WHERE `of`.IsFolder=0 AND `of`.TableID=' . intval($we_doc->ID), true));
			}
		}
		echo we_html_tools::getHtmlTop('', '', '', we_html_element::jsScript(JS_DIR . 'editor_save.js', '', [
				'id' => 'loadVarEditor_save',
				'data-editorSave' => setDynamicVar([
					'we_editor_save' => true,
					'we_transaction' => $we_transaction,
					'isHot' => ($we_responseText && $we_responseTextType === we_base_util::WE_MESSAGE_ERROR),
					'wasSaved' => $wasSaved,
					'wasPublished' => !empty($we_doc->Published),
					'isPublished' => $publish_doc,
					'isSEEMode' => $_SESSION['weS']['we_mode'] === we_base_constants::MODE_SEE,
					'reloadEditors' => array_filter($reload),
					'ContentType' => $we_doc->ContentType,
					'docID' => $we_doc->ID,
					'EditPageNr' => $we_doc->EditPageNr,
					'saveTmpl' => $saveTemplate,
					'isClose' => $isClose,
					'showAlert' => $showAlert,
					'we_responseText' => $we_responseText,
					'we_responseTextType' => $we_responseTextType,
					'we_JavaScript' => $wejs,
					'we_cmd5' => we_base_request::_(we_base_request::JSON, 'we_cmd', '', 5), // this is we_responseJS through save-template-question
					'we_responseJS' => $we_responseJS,
					'docHasPreview' => in_array(we_base_constants::WE_EDITPAGE_PREVIEW, $we_doc->EditPageNrs),
			])]), we_html_element::body());
	}

	public static function templateSave($we_transaction){

		echo we_html_tools::getHtmlTop('', '', '', we_html_element::jsElement('var url=WE().consts.dirs.WEBEDITION_DIR+"we_cmd.php?' . http_build_query(
					['we_cmd' => [
							0 => 'save_document',
							1 => $we_transaction,
							2 => 1,
							5 => we_base_request::_(we_base_request::RAW, 'we_cmd', '', 5), //is json64
							6 => we_base_request::_(we_base_request::RAW, 'we_cmd', '', 6), //is json64
						],
						'we_transaction' => $we_transaction,
						'we_complete_request' => 1
					], null, '&') .
				'";
new (WE().util.jsWindow)(window, url,"templateSaveQuestion",WE().consts.size.dialog.smaller,WE().consts.size.dialog.tiny,true,false,true);
'), '<body></body>');
	}

	public static function templateSaveQuestion($we_transaction, $isTemplatesUsedByThisTemplate, $nrDocsUsedByThisTemplate, $we_responseJS){
		$we_cmd6 = we_base_request::_(we_base_request::JSON, 'we_cmd', '', 6);

		$alerttext = ($isTemplatesUsedByThisTemplate ?
			g_l('alert', '[template_save_warning2]', false, true) :
			sprintf((g_l('alert', ($nrDocsUsedByThisTemplate === 1) ? '[template_save_warning1]' : '[template_save_warning]', false, true)), $nrDocsUsedByThisTemplate)
			);

		echo we_html_tools::getHtmlTop(g_l('global', '[question]'), '', '', we_html_element::jsScript(JS_DIR . 'template_save_question.js', '', ['id' => 'loadVarTemplate_save_question',
				'data-editorSave' => setDynamicVar([
					'we_transaction' => $we_transaction,
					'we_responseJS' => $we_responseJS,
					'we_cmd6' => $we_cmd6
			])]), we_html_element::body(['class' => "weEditorBody", 'onload' => "self.focus();", 'onblur' => "self.focus()"], we_html_tools::yesNoCancelDialog($alerttext, '<span class="fa-stack fa-lg" style="color:#F2F200;"><i class="fa fa-exclamation-triangle fa-stack-2x" ></i><i style="color:black;" class="fa fa-exclamation fa-stack-1x"></i></span>', true, true, true, 'pressed_yes_button()', 'pressed_no_button()', 'pressed_cancel_button()')
			)
		);
	}

	public static function processSave($we_doc, $we_transaction, $wasSaved, $saveTemplate, $isClose, $showAlert, array $wejs, $we_responseText = '', $we_responseTextType = 0){
		if(($tmp = $we_doc->getErrMsg())){
			$we_responseText .= '\n\n' . $tmp;
			$we_responseTextType = we_base_util::WE_MESSAGE_ERROR;
		}
		if(($tmp = $we_doc->getWarningMsg())){
			$we_responseText .= '\n\n' . $tmp;
			$we_responseTextType = $we_responseTextType < we_base_util::WE_MESSAGE_WARNING ? we_base_util::WE_MESSAGE_WARNING : $we_responseTextType;
		}
		if(($tmp = $we_doc->getNoticeMsg())){
			$we_responseText .= '\n\n' . $tmp;
			$we_responseTextType = $we_responseTextType < we_base_util::WE_MESSAGE_NOTICE ? we_base_util::WE_MESSAGE_NOTICE : $we_responseTextType;
		}
		if($_SERVER['REQUEST_METHOD'] === 'POST' && !we_base_request::_(we_base_request::BOOL, 'we_complete_request')){
			//will show the message
			$jsCmd = new we_base_jsCmd();
			$jsCmd->addMsg(g_l('weEditor', '[incompleteRequest]'), we_base_util::WE_MESSAGE_ERROR);
			echo $jsCmd->getCmds();
			return;
		}
		$we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]); // save the changed object in session

		$wejs[] = ['setEditorDocumentId', $we_doc->ID]; // save/ rename a document
		self::saveInc($we_transaction, $we_doc, strtr($we_responseText, ['\n' => we_html_element::br()]), $we_responseTextType, $wejs, $wasSaved, $saveTemplate, empty($GLOBALS['we_responseJS']) ? [
				] : $GLOBALS['we_responseJS'], $isClose, $showAlert, !empty($GLOBALS['publish_doc']));
		if(we_modules_info::isActive(we_modules_info::SCHEDULER) && SCHEDULER_TRIGGER !== SCHEDULER_TRIGGER_CRON){
			finishRequest();
			we_schedule_scheduler::trigger_schedule(5);
		}
	}

	//if document is locked - only Preview mode is possible. otherwise show warning.
	public static function documentLocking($we_doc){
		$userID = $we_doc->isLockedByUser();
		if($userID != 0 && $userID != $_SESSION['user']['ID'] && $we_doc->ID){ // document is locked
			if(in_array(we_base_constants::WE_EDITPAGE_PREVIEW, $we_doc->EditPageNrs) && !($we_doc instanceof we_template)){
				$we_doc->EditPageNr = we_base_constants::WE_EDITPAGE_PREVIEW;
				$_SESSION['weS']['EditPageNr'] = we_base_constants::WE_EDITPAGE_PREVIEW;
			} else if($we_doc instanceof we_folder){
				$target = in_array(we_base_constants::WE_EDITPAGE_DOCLIST, $we_doc->EditPageNrs) ? we_base_constants::WE_EDITPAGE_DOCLIST : we_base_constants::WE_EDITPAGE_FIELDS;
				$we_doc->EditPageNr = $target;
				$_SESSION['weS']['EditPageNr'] = $target;
			} else {
				$we_doc->showLockedWarning($userID);
			}
		} elseif($userID != $_SESSION['user']['ID'] && $_SESSION['weS']['we_mode'] == we_base_constants::MODE_SEE && $we_doc->EditPageNr != we_base_constants::WE_EDITPAGE_PREVIEW){
// lock document, if in seeMode and EditMode !!, don't lock when already locked
			$we_doc->lockDocument();
		}
	}

	public static function saveTemplate($we_doc, $we_transaction, array &$wejs){
		$wasNew = $wasSaved = false;
		$we_responseText = $we_responseTextType = '';
		$doAutomaticRebuild = (we_base_request::_(we_base_request::BOOL, 'we_cmd', false, 8));
		if($doAutomaticRebuild){
// if  we_cmd[8] is set, it means that 'automatic rebuild' was clicked
// so we need to check we_cmd[3] (means save immediately) and we_cmd[4] (means rebuild immediately)
			$_REQUEST['we_cmd'][3] = 1;
			$_REQUEST['we_cmd'][4] = 1;
		}
		if(we_base_request::_(we_base_request::BOOL, 'we_cmd', false, 5)){ //Save in version
			$_REQUEST['we_cmd'][5] = false;
			$we_doc->we_publish();
		}

		$arr = we_rebuild_base::getTemplAndDocIDsOfTemplate($we_doc->ID, true, true);
		$nrDocsUsedByThisTemplate = $arr && count($arr['documentIDs']);
		$isTemplatesUsedByThisTemplate = $we_doc->ID && f('SELECT 1 FROM ' . TEMPLATES_TABLE . ' WHERE MasterTemplateID=' . $we_doc->ID . ' LIMIT 1');
		$somethingNeedsToBeResaved = ($nrDocsUsedByThisTemplate + $isTemplatesUsedByThisTemplate) > 0;

		if(we_base_request::_(we_base_request::BOOL, 'we_cmd', false, 2)){
//this is the second call to save_document (see next else command)
			we_editor_functions::templateSaveQuestion($we_transaction, $isTemplatesUsedByThisTemplate, $nrDocsUsedByThisTemplate, empty($GLOBALS['we_responseJS']) ? '' : $GLOBALS['we_responseJS']);
			$we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]); // save the changed object in session
			exit();
		}
		if(!we_base_request::_(we_base_request::BOOL, 'we_cmd', false, 3) && $somethingNeedsToBeResaved){
// this happens when the template is saved and there are documents which use the template and "automatic rebuild" is not checked!
			we_editor_functions::templateSave($we_transaction); // this calls again we_cmd with save_document and sets we_cmd[2]
			$we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]); // save the changed object in session
			exit();
		}
//this happens when we_cmd[3] is set and not we_cmd[2]
		$oldID = $we_doc->ID;
		if($we_doc->we_save()){
			if($oldID == 0){
				$we_doc->lockDocument();
			}
			$wasSaved = true;
			$wasNew = (intval($we_doc->ID) === 0);

			$wejs[] = ['we_setPath', $we_doc->Path, $we_doc->Text, intval($we_doc->ID), ($we_doc->Published > 0 ? ($we_doc->Table !== TEMPLATES_TABLE && $we_doc->ModDate > $we_doc->Published ? 'changed' : 'published') : 'notpublished')];
			$wejs[] = ['setEditorDocumentId', $we_doc->ID];
			$wejs[] = $we_doc->getUpdateTreeScript(true, null, true); // save/ rename a document
			$we_responseText = sprintf(g_l('weEditor', '[' . $we_doc->ContentType . '][response_save_ok]', true) ?: g_l('weClass', '[response_save_ok]'), $we_doc->Path);
			$we_responseTextType = we_base_util::WE_MESSAGE_NOTICE;
			if(we_base_request::_(we_base_request::BOOL, 'we_cmd', false, 4)){
// this happens when the documents which uses the templates has to be rebuilt. (if user clicks "yes" at template save question or if automatic rebuild was set)
				if($somethingNeedsToBeResaved){
					$wejs[] = ['unsetHot'];
					$wejs[] = ['rebuildTemplates', $we_doc->ID, sprintf($we_responseText, $we_doc->Path)];
					$we_responseText = '';
				}
			}
		} else {
// we got an error while saving the template
			$wejs = [];
			$we_responseText = sprintf(g_l('weEditor', '[' . $we_doc->ContentType . '][response_save_notok]', true) ?: g_l('weClass', '[response_save_notok]'), $we_doc->Path);
			$we_responseTextType = we_base_util::WE_MESSAGE_ERROR;
		}

//FIXME: is this safe??? Code-Injection!
		if(($js = we_base_request::_(we_base_request::JSON, 'we_cmd', '', 6))){
			$wejs[] = $js;
		}
		return [$wasNew, $wasSaved, $we_responseText, $we_responseTextType];
	}

	public static function doUnpublish(){
		$we_doc = self::initVars();
		$we_transaction = $GLOBALS['we_transaction'];
		if(!$we_doc->Published){
			self::unPublishInc($we_transaction, sprintf(g_l('weEditor', '[' . $we_doc->ContentType . '][response_not_published]'), $we_doc->Path), we_base_util::WE_MESSAGE_ERROR);
			return;
		}
		$jsCmd = new we_base_jsCmd();
		if($we_doc->we_unpublish()){
			$we_responseText = sprintf(g_l('weEditor', '[' . $we_doc->ContentType . '][response_unpublish_ok]'), $we_doc->Path);
			$we_responseTextType = we_base_util::WE_MESSAGE_NOTICE;
			if($we_doc->EditPageNr == we_base_constants::WE_EDITPAGE_PROPERTIES || $we_doc->EditPageNr == we_base_constants::WE_EDITPAGE_INFO){
				$GLOBALS['we_responseJS'][] = ['switch_edit_page', $we_doc->EditPageNr, $we_transaction]; // wird in Templ eingef?gt
			}
//	When unpublishing a document stay where u are.
//	uncomment the following line to switch to preview page.
			$GLOBALS['we_responseJS'][] = ['reload_editfooter', $we_transaction];
			$jsCmd->addCmd('setEditorDocumentId', $we_doc->ID);
			$we_doc->getUpdateTreeScript(true, $jsCmd); // save/ rename a document
		} else {
			$we_responseText = sprintf(g_l('weEditor', '[' . $we_doc->ContentType . '][response_unpublish_notok]', true) ?: g_l('weClass', '[response_unpublish_notok]'), $we_doc->Path);
			$we_responseTextType = we_base_util::WE_MESSAGE_ERROR;
		}
		if($_SERVER['REQUEST_METHOD'] === 'POST' && !we_base_request::_(we_base_request::BOOL, 'we_complete_request')){
			$we_responseText = g_l('weEditor', '[incompleteRequest]');
			$we_responseTextType = we_base_util::WE_MESSAGE_ERROR;
		} else {
			$we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]); // save the changed object in session
		}
		self::unPublishInc($we_transaction, $we_responseText, $we_responseTextType, $jsCmd, $GLOBALS['we_responseJS']);
	}

	public static function saveDocument(){
		//FIXME: make this a better, local var
		global $we_JavaScript;
		$we_doc = self::initVars();
		$we_transaction = $GLOBALS['we_transaction'];
		$makeSameDoc = we_base_request::_(we_base_request::BOOL, 'we_cmd', false, 4);
		$we_JavaScript = [];

		$wasNew = $showAlert = $isClose = $wasSaved = $saveTemplate = false;


		if(!$we_doc->ContentType){
			exit(' ContentType Missing !!! ');
		}
		if(($we_responseText = $we_doc->checkFieldsOnSave())){
			we_editor_functions::processSave($we_doc, $we_transaction, false, false, false, false, [], $we_responseText, we_base_util::WE_MESSAGE_ERROR);
			exit();
		}

		if($we_doc->ID){
			$we_JavaScript[] = ['setEditorDocumentId', $we_doc->ID]; // save/ rename a document
		}
		switch($we_doc->ContentType){
			case we_base_ContentTypes::TEMPLATE:
				$saveTemplate = true;
				list($wasNew, $wasSaved, $we_responseText, $we_responseTextType) = we_editor_functions::saveTemplate($we_doc, $we_transaction, $we_JavaScript);
				break;
			case we_base_ContentTypes::PDF:
			case we_base_ContentTypes::APPLICATION:
				if((!we_base_permission::hasPerm(we_base_perm::WORK_OTHER_NEW)) && in_array($we_doc->Extension, we_base_ContentTypes::getExtension(we_base_ContentTypes::HTML))){
					we_editor_functions::processSave($we_doc, $we_transaction, false, false, false, false, [], sprintf(g_l('weEditor', '[application/*][response_save_wrongExtension]'), $we_doc->Path, $we_doc->Extension), we_base_util::WE_MESSAGE_ERROR);
					exit();
				}
			//falls through
			default:
				$we_responseTextType = we_base_util::WE_MESSAGE_NOTICE;
				$wf_flag = false;
				$wasNew = (intval($we_doc->ID) == 0);
				$wasPubl = (!empty($we_doc->Published));
				if(!we_base_permission::hasPerm(we_base_perm::ADMINISTRATOR) && $we_doc->ContentType != we_base_ContentTypes::OBJECT && $we_doc->ContentType != we_base_ContentTypes::OBJECT_FILE && !we_users_util::in_workspace($we_doc->ParentID, get_ws($we_doc->Table, true), $we_doc->Table)){
					we_editor_functions::saveInc($we_transaction, $we_doc, g_l('alert', '[' . FILE_TABLE . '][not_im_ws]'), we_base_util::WE_MESSAGE_ERROR, [], false, false, $GLOBALS['we_responseJS'], false, false, !empty($GLOBALS['publish_doc']));
					exit();
				}
				if(!$we_doc->userCanSave()){
					we_editor_functions::saveInc($we_transaction, $we_doc, g_l('alert', '[access_denied]'), we_base_util::WE_MESSAGE_ERROR, [], false, false, $GLOBALS['we_responseJS'], false, false, !empty($GLOBALS['publish_doc']));
					exit();
				}

				$oldID = $we_doc->ID;
				if(!$we_doc->we_save()){
					we_editor_functions::processSave($we_doc, $we_transaction, false, false, false, false, [], sprintf(g_l('weEditor', '[' . $we_doc->ContentType . '][response_save_notok]', true) ?: g_l('weClass', '[response_save_notok]'), $we_doc->Path), we_base_util::WE_MESSAGE_ERROR);
					exit();
				}

				if($oldID == 0){
					$we_doc->lockDocument();
				}
				$wasSaved = true;
				switch($we_doc->ContentType){
					case we_base_ContentTypes::OBJECT:
						$we_JavaScript[] = ['updateVTab', OBJECT_FILES_TABLE];
						break;
					case we_base_ContentTypes::COLLECTION:
						$we_JavaScript[] = ['updateVTab', VFILE_TABLE];
						break;
				}
				$err = $we_doc->getErrMsg(true);
				$we_responseText = sprintf(g_l('weEditor', '[' . $we_doc->ContentType . '][response_save_ok]', true) ?: g_l('weClass', '[response_save_ok]'), $we_doc->Path) . ($err ? ' - ' . $err : '');


				if(we_base_request::_(we_base_request::BOOL, 'we_cmd', false, 5)){
					if(($foo = $we_doc->publInScheduleTable())){
						//if(($foo = $we_doc->getNextPublishDate())){
						$we_responseText .= ' - ' . sprintf(g_l('weEditor', '[' . $we_doc->ContentType . '][autoschedule]'), date(g_l('date', '[format][default]'), $foo));
						//}
					} elseif($we_doc->we_publish()){
						if(we_modules_info::isActive(we_modules_info::WORKFLOW) && (we_workflow_utility::inWorkflow($we_doc->ID, $we_doc->Table))){
							we_workflow_utility::removeDocFromWorkflow($we_doc->ID, $we_doc->Table, $_SESSION['user']['ID'], '');
						}
						// FIXME: fast and dirty fix for wrong messages: we should avoid publishing at all when not needed!
						if(in_array($we_doc->ContentType, [we_base_ContentTypes::WEDOCUMENT, we_base_ContentTypes::OBJECT_FILE, we_base_ContentTypes::HTML])){
							$we_responseText .= ' - ' . sprintf(g_l('weEditor', '[' . $we_doc->ContentType . '][response_publish_ok]'), $we_doc->Path);
						}
// SEEM, here a doc is published
						$GLOBALS['publish_doc'] = true;
						switch($we_doc->EditPageNr){
							case we_base_constants::WE_EDITPAGE_PROPERTIES:
							case we_base_constants::WE_EDITPAGE_INFO:
							case we_base_constants::WE_EDITPAGE_PREVIEW:
								if($_SESSION['weS']['we_mode'] !== we_base_constants::MODE_SEE && (!$makeSameDoc)){
									$GLOBALS['we_responseJS'][] = ['switch_edit_page', $we_doc->EditPageNr, $we_transaction];
									$GLOBALS['we_responseJS'][] = ['reload_editfooter', $we_transaction]; // reload the footer with the buttons
								}
						}
					} else {
						$we_responseText .= ' - ' . sprintf(g_l('weEditor', '[' . $we_doc->ContentType . '][response_publish_notok]'), $we_doc->Path);
						$we_responseTextType = we_base_util::WE_MESSAGE_ERROR;
					}
				} else {
					//in case we only save the document, make updates to schedule table as well
					if(($foo = $we_doc->publInScheduleTable())){
						//if(($foo = $we_doc->getNextPublishDate())){
						$we_responseText .= ' - ' . sprintf(g_l('weEditor', '[' . $we_doc->ContentType . '][autoschedule]'), date(g_l('date', '[format][default]'), $foo));
						//}
					}
					$tmp = we_base_request::_(we_base_request::INT, 'we_cmd', 0, 7);
					if(($we_doc->EditPageNr == we_base_constants::WE_EDITPAGE_INFO && (!$makeSameDoc)) || $tmp){
						$we_responseText = $tmp ? '' : $we_responseText;
						$we_responseTextType = $tmp ? we_base_util::WE_MESSAGE_ERROR : $we_responseTextType;
						$GLOBALS['we_responseJS'][] = ['switch_edit_page', $we_doc->EditPageNr, $we_transaction];

						switch($tmp){
							case 1:
								$we_JavaScript[] = ['workflow_isIn', $we_transaction, $makeSameDoc];
								$wf_flag = true;
								break;
							case 2:
								$we_JavaScript[] = ['workflow_pass', $we_transaction];
								$wf_flag = true;
								break;
							case 3:
								$we_JavaScript[] = ['workflow_decline', $we_transaction];
								$wf_flag = true;
								break;
							default:
						}
					}
// Bug Fix #2065 -> Reload Preview Page of other documents
					elseif($we_doc->EditPageNr == we_base_constants::WE_EDITPAGE_PREVIEW){
						switch($we_doc->ContentType){
							case we_base_ContentTypes::APPLICATION:
							case we_base_ContentTypes::PDF:
								$we_JavaScript[] = ['switch_edit_page', $we_doc->EditPageNr, $we_transaction];
						}
					}
				}

				$we_JavaScript[] = $we_doc->getUpdateTreeScript(!$makeSameDoc, null, true);

				if($wasNew || (!$wasPubl)){
					if($we_doc->ContentType === we_base_ContentTypes::FOLDER){
						$we_JavaScript[] = ['switch_edit_page', $we_doc->EditPageNr, $we_transaction];
					}
					$we_JavaScript[] = ['reload_editfooter', $we_transaction];
					$we_JavaScript[] = ['reload_edit_header', $we_transaction];
				}
				$we_JavaScript[] = ['we_setPath', $we_doc->Path, $we_doc->Text, intval($we_doc->ID), ($we_doc->Published > 0 ? ($we_doc->Table !== TEMPLATES_TABLE && $we_doc->ModDate > $we_doc->Published ? 'changed' : 'published') : 'notpublished')];

				if(!we_modules_info::isActive(we_modules_info::SCHEDULER)){
					$we_JavaScript[] = ['setEditorDocumentId', $we_doc->ID];
				}
				if($we_doc->canHaveVariants(true)){
					we_base_variants::setVariantDataForModel($we_doc, true);
				}

				if(($js = we_base_request::_(we_base_request::JSON, 'we_cmd', '', 6))){
					$we_JavaScript[] = $js;
					$isClose = in_array('closeDocument', $js);
				} else if($makeSameDoc && (!$wf_flag)){
					$we_doc->makeSameNew();
					$we_JavaScript[] = ['we_setPath', $we_doc->Path, $we_doc->Text, intval($we_doc->ID), ($we_doc->Published > 0 ? ($we_doc->Table !== TEMPLATES_TABLE && $we_doc->ModDate > $we_doc->Published ? 'changed' : 'published') : 'notpublished')];
//	switch to propertiy page, when user is allowed to do so.
					switch($_SESSION['weS']['we_mode']){
						case we_base_constants::MODE_SEE:
							$showAlert = true; //	don't show confirm box in editor_save.inc
							$GLOBALS['we_responseJS'][] = ['switch_edit_page', (we_base_permission::hasPerm(we_base_perm::WORK_PROPERTIES_CAN_SEE) ? we_base_constants::WE_EDITPAGE_PROPERTIES : $we_doc->EditPageNr),
								$we_transaction];
							break;
						case we_base_constants::MODE_NORMAL:
							$GLOBALS['we_responseJS'][] = ['switch_edit_page', $we_doc->EditPageNr, $we_transaction];
							break;
					}
				}
		}

		if($wasNew){ // add to history
			$we_JavaScript[] = ['addHistory', $we_doc->Table, $we_doc->ID, $we_doc->ContentType];
		}
		we_editor_functions::processSave($we_doc, $we_transaction, $wasSaved, $saveTemplate, $isClose, $showAlert, $we_JavaScript, $we_responseText, $we_responseTextType);
	}

	public static function includeEditor($we_doc, $we_transaction, we_base_jsCmd $jsCmd = null){
// prevent persmissions overriding
		$perms = $_SESSION['perms'];
		if(isset($we_doc->IsDynamic) && !$we_doc->IsDynamic){
			switch($we_doc->EditPageNr){
				case we_base_constants::WE_EDITPAGE_CONTENT:
					if($we_doc->ContentType !== we_base_ContentTypes::WEDOCUMENT){
						break;
					}
				case we_base_constants::WE_EDITPAGE_PREVIEW:
					if($we_doc->ContentType === we_base_ContentTypes::WEDOCUMENT ||
						$we_doc->ContentType === we_base_ContentTypes::HTML){
						self::includeEditorStatic($we_doc, $we_transaction, $jsCmd);
						$_SESSION['perms'] = $perms;
						return;
					}
			}
		}
		self::includeEditorDefault($we_doc, $we_transaction, $jsCmd);
		$_SESSION['perms'] = $perms;
	}

	/*
	 * if the document is a webEdition document, we save it with a temp-name (path of document+extension) and redirect
	 * to the tmp-location. This is done for the content- and preview-editpage.
	 * With html-documents this is only done for preview-editpage.
	 * We need to do this, because, when the pages has for example jsp. content, it will be parsed right!
	 * This is only done when the IsDynamic - PersistantSlot is false.
	 */

	private static function includeEditorStatic($we_doc, $we_transaction, we_base_jsCmd $jsCmd = null){//this is really unclear what is done here
		$we_include = $we_doc->editor($jsCmd);
		if(!$we_include){ // object does not handle html-output, so we need to include a template( return value)
			exit('Nothing to include ...');
		}

		if($we_doc->ContentType === we_base_ContentTypes::WEDOCUMENT){
//remove all already parsed names
			$we_doc->resetUsedElements();
		}
		if(is_object($we_include)){
			$docContents = $we_include->show();
		} else {
			ob_start();
			include((substr(strtolower($we_include), 0, strlen($_SERVER['DOCUMENT_ROOT'])) === strtolower($_SERVER['DOCUMENT_ROOT']) ?
					'' : WE_INCLUDES_PATH) .
				$we_include);
			$docContents = ob_get_clean();
		}

		//usedElementNames is set after include
		$we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]); // save the changed object in session
//  SEEM the file
//  but only, if we are not in the template-editor
		switch($we_doc->ContentType){
			case we_base_ContentTypes::TEMPLATE:
				$contents = $docContents;
				break;
			default:
				$tmpcontents = we_gui_SEEM::parseDocument($docContents);

				$contents = ($jsCmd && !$jsCmd->isEmpty() ? (strpos($tmpcontents, '</head>') ?
					str_replace('</head>', $jsCmd->getCmds() . '</head>', $tmpcontents) :
					$jsCmd->getCmds() . $tmpcontents) :
					$tmpcontents
					);
		}

		switch($we_doc->Extension){
			case '.js':
			case '.css':
			case '.wml':
			case '.xml':
				$tempName = we_base_file::getUniqueId() . '.html';
				break;
			default:
				$tempName = we_base_file::getUniqueId() . $we_doc->Extension;
		}

//
// --> Glossary Replacement
//

		$glossarHTML = ((we_modules_info::isActive(we_modules_info::GLOSSARY) && (!isset($GLOBALS['we']['editmode']) || (isset($GLOBALS['we']['editmode']) && !$GLOBALS['we']['editmode'])) && isset($we_doc->InGlossar) && $we_doc->InGlossar == 0) ?
			we_glossary_replace::replace($contents, $we_doc->Language) :
			$contents);

		if(!empty($GLOBALS['we']['editmode'])){
			$matches = [];
			preg_match_all('|<form( name="we_form")|i', $glossarHTML, $matches, PREG_PATTERN_ORDER);
			if($matches && !empty($matches[0])){
				//find the number of we-forms
				$all = count($matches[0]);
				$no = count(array_filter($matches[1]));
				if($no > 1){
					//sth very bad must have happend to have 2 we forms in one page
					$warn = $no . ' ' . g_l('parser', '[form][we]');
					t_e($warn, str_replace('.html', '.tmpl', $we_doc->Path));
				}
				if($all - $no){
					$warn = $no . ' ' . g_l('parser', '[form][duplicate]');
					t_e($warn, str_replace('.html', '.tmpl', $we_doc->Path));
				}
			}
		}
		we_base_file::saveTemp($glossarHTML, $tempName, 60);

		header('Location: ' . WEBEDITION_DIR . 'showTempFile.php?charset=' . (empty($GLOBALS['we']['Charset']['Page']) ? DEFAULT_CHARSET : $GLOBALS['we']['Charset']['Page']) . '&file=' . str_replace(WEBEDITION_DIR, '', TEMP_DIR . $tempName));
	}

	private static function includeEditorDefault($we_doc, $we_transaction, we_base_jsCmd $jsCmd = null){
		$we_include = $we_doc->editor($jsCmd);
		if(!$we_include){ // object does not handle html-output, so we need to include a template( return value)
			exit('Nothing to include ...');
		}

		/* At this point complete requests are not common
		  if(!isset($_REQUEST['we_complete_request'])){
		  $we_responseText = g_l('weEditor', '[incompleteRequest]');
		  $we_responseTextType = we_base_util::WE_MESSAGE_ERROR;
		  } */
		//$we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]); // save the changed object in session
		if(!is_object($we_include) && $_SERVER['DOCUMENT_ROOT'] && substr(strtolower($we_include), 0, strlen($_SERVER['DOCUMENT_ROOT'])) == strtolower($_SERVER['DOCUMENT_ROOT'])){

			if(empty($GLOBALS['we']['Charset']['Page'])){
				$charset = $we_doc->getElement('Charset', we_contents_base::ETYPE_TEXT, DEFAULT_CHARSET, true); //	send charset which might be determined in template
				$GLOBALS['we']['Charset']['Page'] = $charset;
				we_html_tools::headerCtCharset('text/html', $charset);
			}

			ob_start();
			$we_include = (file_exists($we_include) ? $we_include : WE_INCLUDES_PATH . 'we_editors/' . we_template::NO_TEMPLATE_INC);
			include($we_include);
			$contents = ob_get_clean();

//  SEEM the file
//  but only, if we are not in the template-editor
			switch($we_doc->ContentType){
				case we_base_ContentTypes::TEMPLATE:
					if($we_doc->EditPageNr != we_base_constants::WE_EDITPAGE_PREVIEW_TEMPLATE){
						echo $contents;
						break;
					}
				default:
					$tmpCnt = we_gui_SEEM::parseDocument($contents);

// insert $reloadFooter at right place
					$tmpCntHTML = ($jsCmd && !$jsCmd->isEmpty() ? (strpos($tmpCnt, '</head>') ?
						str_replace('</head>', $jsCmd->getCmds() . '</head>', $tmpCnt) :
						$jsCmd->getCmds() . $tmpCnt) :
						$tmpCnt);

// --> Start Glossary Replacement

					$useGlossary = ((we_modules_info::isActive(we_modules_info::GLOSSARY) && (empty($GLOBALS['we']['main']['id']) || $GLOBALS['we']['main']['id'] == $GLOBALS['we_doc']->ID)) && (isset($we_doc->InGlossar) && $we_doc->InGlossar == 0) && (!isset($GLOBALS['we']['editmode']) || (isset($GLOBALS['we']['editmode']) && !$GLOBALS['we']['editmode'])) && we_glossary_replace::useAutomatic());

					echo ($useGlossary ? we_glossary_replace::doReplace($tmpCntHTML, $GLOBALS['we_doc']->Language) : $tmpCntHTML);
			}
		} else {
//  These files were edited only in source-code mode, so no seeMode is needed.
			if(is_object($we_include)){
				echo $we_include->show();
			} else {
				include((preg_match('#^' . WEBEDITION_DIR . 'we/#', $we_include) ? $_SERVER['DOCUMENT_ROOT'] : WE_INCLUDES_PATH) . $we_include);
			}
			echo ($jsCmd ? $jsCmd->getCmds() : '');
		}
		$we_doc->saveInSession($_SESSION['weS']['we_data'][$we_transaction]); // save the changed object in session
	}

}
