<?php

/**
 * webEdition CMS
 *
 * $Rev: ea0126cfffc5 $
 * $Author: Lukas Imhof <lukas.imhof@webedition.org> $
 * $Date: 2018-05-31 10:03 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_rpcCmd_categoryGet extends we_rpc_cmd{

	function execute(){
		$resp = new we_rpc_response();
		$error = [];
		// check for necessory params
		if(!($obj = we_base_request::_(we_base_request::STRING, 'obj'))){
			$error[] = 'Missing field obj';
		}
		if(!we_base_request::_(we_base_request::STRING, 'cats')){
			$error[] = 'Missing field cats';
		}
		if(we_base_request::_(we_base_request::STRING, 'part') === 'table' && (!we_base_request::_(we_base_request::BOOL, 'target'))){
			$error[] = 'Missing target for table';
		}

		if($error){
			$resp->setData('error', $error);
		} else {
			//$part = we_base_request::_(we_base_request::STRING, 'part',"rows");
			$target = we_base_request::_(we_base_request::STRING, 'target', $obj . 'CatTable');
			$catField = we_base_request::_(we_base_request::STRING, 'catfield', '');
			$categories = strtr($this->getCategory($obj, we_base_request::_(we_base_request::INTLIST, 'cats', ''), $catField), ["\r" => '', "\n" => '']);
			$resp->setData('elements', [$target => ['innerHTML' => $categories]]);
		}
		return $resp;
	}

	function getCategory($obj, $categories, $catField = ''){
		$cats = new we_chooser_multiDirExtended(410, $categories, 'delete_' . $obj . 'Cat', '', '', '"' . we_base_ContentTypes::CATEGORY . '"', CATEGORY_TABLE);
		$cats->setRowPrefix($obj);
		$cats->setCatField($catField);
		$cats->setOnchangeSetHot(false);
		return $cats->getTableRows();
	}

}
