<?php

/**
 * webEdition CMS
 *
 * $Rev: b2e2950d4ecc $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-08-28 18:56 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_charset extends we_weTag_tag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		$content = empty($GLOBALS['we']['Charset']['Page']) ? $content : $GLOBALS['we']['Charset']['Page'];
		if(!empty($GLOBALS['we']['editmode']) && $GLOBALS['we_doc']->EditPageNr === we_base_constants::WE_EDITPAGE_PROPERTIES){
			//set meta data & exit
			$GLOBALS['meta']['Charset'] = [
				'default' => $content,
				'defined' => self::getAttribute('defined', $attribs, '', we_base_request::STRING),
			];
			return '';
		}

		if($content){ //	set charset
			$attribs['charset'] = $content;
			if(!headers_sent()){
				header('Content-Type: ' . 'text/html; charset=' . $content);
			}

			return getHtmlTag('meta', removeAttribs($attribs, ['defined', '_type'])) . "\n";
		}
		return '';
	}

}

function we_tag_charset(array $attribs, $content){
	return we_tag_charset::tag($attribs, $content);
}
