<?php

/**
 * webEdition CMS
 *
 * $Rev: b0952fdcba04 $
 * $Author: mokraemer $
 * $Date: 2019-06-06 12:46 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_ifVarSet extends we_weTag_ifTag{

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(($foo = self::attributeMissing($attribs, 'name', __CLASS__))){
			echo $foo;
			return false;
		}

		$type = self::getAttribute('type', $attribs, self::getAttribute('var', $attribs, '', we_base_request::STRING, true), we_base_request::STRING);
		$docAttr = self::getAttribute('doc', $attribs, '', we_base_request::STRING);
		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);
		$orig = self::getAttribute('_name_orig', $attribs, '', we_base_request::STRING);
		$formname = self::getAttribute('formname', $attribs, we_base_constants::DEFAULT_FORM, we_base_request::STRING);
		$property = self::getAttribute('property', $attribs, false, we_base_request::BOOL);
		$shopname = self::getAttribute('shopname', $attribs, '', we_base_request::STRING);

		switch($type){
			case 'cookie' :
				return self::getArrayValue($_COOKIE, null, $orig, true);
			case 'request' :
				return self::getArrayValue($_REQUEST, null, $orig, true);
			case 'post' :
				return self::getArrayValue($_POST, null, $orig, true);
			case 'get' :
				return self::getArrayValue($_GET, null, $orig, true);
			case 'global' :
				return self::getArrayValue($GLOBALS, null, $name, true) || self::getArrayValue($GLOBALS, null, $orig, true);
			case 'session' :
				return self::getArrayValue($_SESSION, null, $orig, true);
			case 'sessionfield' :
				return isset($_SESSION['webuser'][$orig]);
			case 'shopField' :
				return (isset($GLOBALS[$shopname]) ? $GLOBALS[$shopname]->hasCartField($orig) : false);
			case 'sum' :
				return (we_tag_sum::getSum($orig) !== false);
		}

		switch($docAttr){
			case 'object' :
			case 'document' :
				$doc = isset($GLOBALS['we_' . $docAttr][$formname]) ? $GLOBALS['we_' . $docAttr][$formname] : false;
				break;
			case 'top' :
				$doc = empty($GLOBALS['we']['main']['doc']) ? false : $GLOBALS['we']['main']['doc'];
				break;
			default:
				$doc = isset($GLOBALS['we_doc']) ? $GLOBALS['we_doc'] : false;
		}
		if(!$doc){
			return false;
		}
		if($property){
			return isset($doc->$name) || isset($doc->$orig);
		}
		if($type === 'href' && $doc->getElement($name . we_base_link::MAGIC_INT_LINK, we_contents_base::ETYPE_NUMBER, -1) == 0){
			//internal link is empty, check if external link is present
			return $doc->issetElement($name . we_base_link::MAGIC_INT_LINK_EXTPATH);
		}
		if($doc->issetElement($name)){
			switch($doc->getElementType($name)){
				case 'checkbox_feld':
					return intval($doc->getElement($name)) > 0;
				case 'img':
					return intval($doc->getElement($name, we_contents_base::ETYPE_NUMBER)) > 0;
				case 'href'://can be serialized
					return intval($doc->getElement($name, we_contents_base::ETYPE_NUMBER)) > 0 || $doc->getElement($name);
				default:
					return $doc->getElement($name, we_contents_base::ETYPE_UNKNOWN, '__WE__UNSET') !== '__WE__UNSET';
			}
		}
		return false;
	}

}

function we_tag_ifVarSet(array $attribs){
	return we_tag_ifVarSet::tag($attribs);
}
