<?php

/**
 * webEdition CMS
 *
 * $Rev$
 * $Author$
 * $Date$
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_order extends we_weTag_tag{

	public static function parse(array $attribs, $content){
		return '<?php ' . (strpos($content, '$lv') !== false ? 'global $lv;' : '') .
			'if(' . we_weTag_parser::printTag('order', $attribs) . '){?>' . $content . '<?php }
		we_weTag_tag::post_listview(); ?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){
		if(!we_modules_info::isActive(we_modules_info::SHOP)){
			echo self::modulMissingError('Shop', __CLASS__);
			return false;
		}

		$condition = self::getAttribute('condition', $attribs, 0, we_base_request::RAW);
		$id = self::getAttribute('id', $attribs, we_base_request::_(we_base_request::INT, 'we_orderid', 0), we_base_request::INT);

		$hidedirindex = self::getAttribute('hidedirindex', $attribs, TAGLINKS_DIRECTORYINDEX_HIDE, we_base_request::BOOL);


		if($id){
			$unique = md5(uniqid(__FILE__, true));

			$lv = new we_listview_shopOrder($unique, 1, 0, '', 0, '(IntOrderID=' . intval($id) . ')' . ($condition ? ' AND ' . $condition : ''), '', 0, $hidedirindex);
			self::pre_listview($lv);
			return $lv->next_record();
		}

		self::pre_listview(new stdClass());
		return false;
	}

}

function we_tag_order(array $attribs){
	return we_tag_order::tag($attribs);
}
