<?php

/**
 * webEdition CMS
 *
 * $Rev: 22a81a512887 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2018-09-17 16:44 +0000 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_tag_orderitem extends we_weTag_tag{

	public static function parse(array $attribs, $content){
		return '<?php ' . (strpos($content, '$lv') !== false ? 'global $lv;' : '') .
			'if(' . we_weTag_parser::printTag('orderitem', $attribs) . '){?>' . $content . '<?php }
		we_weTag_tag::post_listview(); ?>';
	}

	public static function tag(array $attribs = [], $content = '', $internal = false){

		if(!we_modules_info::isActive(we_modules_info::SHOP)){
			echo self::modulMissingError('Shop', __CLASS__);
			return false;
		}

		$condition = self::getAttribute('condition', $attribs, 0, we_base_request::RAW);
		$we_orderitemid = self::getAttribute('id', $attribs, 0, we_base_request::INT);
		$hidedirindex = self::getAttribute('hidedirindex', $attribs, TAGLINKS_DIRECTORYINDEX_HIDE, we_base_request::BOOL);
		$condition = ($condition ? $condition . ' AND ' : '') . 'IntID=' . $we_orderitemid;
		$id = $we_orderitemid ?: we_base_request::_(we_base_request::INT, 'we_orderitemid', 0);

		if($id){
			$lv = new we_listview_shopOrderitem(0, 1, 0, '', 0, '(IntID=' . intval($id) . ')' . ($condition ? ' AND ' . $condition : ''), '', 0, 0, $hidedirindex);
			self::pre_listview($lv);
			return we_tag_listview::$current->next_record();
		}

		self::pre_listview(new stdClass());
		return false;
	}

}

function we_tag_orderitem(array $attribs){
	return we_tag_orderitem::tag($attribs);
}
